diff --git a/gdbserver/Makefile.in b/gdbserver/Makefile.in
index d912a0babef9..5d0d608e058a 100644
--- a/gdbserver/Makefile.in
+++ b/gdbserver/Makefile.in
@@ -79,7 +79,7 @@ include $(srcdir)/../gdb/silent-rules.mk
 
 # Note that these are overridden by GNU make-specific code below if
 # GNU make is used.  The overrides implement dependency tracking.
-COMPILE.pre = $(CXX) -x c++ $(CXX_DIALECT)
+COMPILE.pre = $(CXX) $(CXX_DIALECT)
 COMPILE.post = -c -o $@
 COMPILE = $(ECHO_CXX) $(COMPILE.pre) $(INTERNAL_CFLAGS) $(COMPILE.post)
 POSTCOMPILE = @true
@@ -162,46 +162,46 @@ INTERNAL_LDFLAGS = $(LDFLAGS) @RDYNAMIC@
 # All source files that go into linking GDB remote server.
 
 SFILES = \
-	$(srcdir)/debug.c \
-	$(srcdir)/dll.c \
-	$(srcdir)/gdbreplay.c \
-	$(srcdir)/hostio.c \
-	$(srcdir)/hostio-errno.c \
-	$(srcdir)/i387-fp.c \
-	$(srcdir)/inferiors.c \
-	$(srcdir)/linux-aarch64-low.c \
-	$(srcdir)/linux-arm-low.c \
-	$(srcdir)/linux-bfin-low.c \
-	$(srcdir)/linux-cris-low.c \
-	$(srcdir)/linux-crisv32-low.c \
-	$(srcdir)/linux-ia64-low.c \
-	$(srcdir)/linux-low.c \
-	$(srcdir)/linux-m32r-low.c \
-	$(srcdir)/linux-m68k-low.c \
-	$(srcdir)/linux-mips-low.c \
-	$(srcdir)/linux-nios2-low.c \
-	$(srcdir)/linux-ppc-low.c \
-	$(srcdir)/linux-s390-low.c \
-	$(srcdir)/linux-sh-low.c \
-	$(srcdir)/linux-sparc-low.c \
-	$(srcdir)/linux-tile-low.c \
-	$(srcdir)/linux-x86-low.c \
-	$(srcdir)/linux-xtensa-low.c \
-	$(srcdir)/mem-break.c \
-	$(srcdir)/proc-service.c \
+	$(srcdir)/debug.cc \
+	$(srcdir)/dll.cc \
+	$(srcdir)/gdbreplay.cc \
+	$(srcdir)/hostio.cc \
+	$(srcdir)/hostio-errno.cc \
+	$(srcdir)/i387-fp.cc \
+	$(srcdir)/inferiors.cc \
+	$(srcdir)/linux-aarch64-low.cc \
+	$(srcdir)/linux-arm-low.cc \
+	$(srcdir)/linux-bfin-low.cc \
+	$(srcdir)/linux-cris-low.cc \
+	$(srcdir)/linux-crisv32-low.cc \
+	$(srcdir)/linux-ia64-low.cc \
+	$(srcdir)/linux-low.cc \
+	$(srcdir)/linux-m32r-low.cc \
+	$(srcdir)/linux-m68k-low.cc \
+	$(srcdir)/linux-mips-low.cc \
+	$(srcdir)/linux-nios2-low.cc \
+	$(srcdir)/linux-ppc-low.cc \
+	$(srcdir)/linux-s390-low.cc \
+	$(srcdir)/linux-sh-low.cc \
+	$(srcdir)/linux-sparc-low.cc \
+	$(srcdir)/linux-tile-low.cc \
+	$(srcdir)/linux-x86-low.cc \
+	$(srcdir)/linux-xtensa-low.cc \
+	$(srcdir)/mem-break.cc \
+	$(srcdir)/proc-service.cc \
 	$(srcdir)/proc-service.list \
-	$(srcdir)/regcache.c \
-	$(srcdir)/remote-utils.c \
-	$(srcdir)/server.c \
-	$(srcdir)/symbol.c \
-	$(srcdir)/target.c \
-	$(srcdir)/thread-db.c \
-	$(srcdir)/utils.c \
-	$(srcdir)/win32-arm-low.c \
-	$(srcdir)/win32-i386-low.c \
-	$(srcdir)/win32-low.c \
-	$(srcdir)/wincecompat.c \
-	$(srcdir)/x86-low.c \
+	$(srcdir)/regcache.cc \
+	$(srcdir)/remote-utils.cc \
+	$(srcdir)/server.cc \
+	$(srcdir)/symbol.cc \
+	$(srcdir)/target.cc \
+	$(srcdir)/thread-db.cc \
+	$(srcdir)/utils.cc \
+	$(srcdir)/win32-arm-low.cc \
+	$(srcdir)/win32-i386-low.cc \
+	$(srcdir)/win32-low.cc \
+	$(srcdir)/wincecompat.cc \
+	$(srcdir)/x86-low.cc \
 	$(srcdir)/../gdb/alloc.c \
 	$(srcdir)/../gdb/arch/arm.c \
 	$(srcdir)/../gdb/arch/arm-get-next-pcs.c \
@@ -469,7 +469,7 @@ TAGS:	${TAGFILES}
 	etags \
 	  `for i in yzzy ${DEPFILES}; do \
 	     if [ x$$i != xyzzy ]; then \
-	       echo ${srcdir}/$$i | sed -e 's/\.o$$/\.c/' \
+	       echo ${srcdir}/$$i | sed -e 's/\.o$$/\.cc/' \
 		 -e 's,/\(arch\|nat\|target\)/,/../\1/,' \
 		 -e 's,/\(gdbsupport\)/,/../../\1/,'; \
 	     fi; \
@@ -481,7 +481,7 @@ clean:
 	rm -f *.o ${ADD_FILES} *~
 	rm -f gdbserver$(EXEEXT) gdbreplay$(EXEEXT) core make.log
 	rm -f $(IPA_LIB)
-	rm -f *-generated.c
+	rm -f *-generated.cc
 	rm -f stamp-xml
 	rm -f $(DEPDIR)/*.Po
 	for i in $(CONFIG_SRC_SUBDIR); do \
@@ -541,19 +541,19 @@ am--refresh:
 
 force:
 
-version-generated.c: Makefile $(srcdir)/../gdb/version.in $(srcdir)/../bfd/version.h $(srcdir)/../gdbsupport/create-version.sh
+version-generated.cc: Makefile $(srcdir)/../gdb/version.in $(srcdir)/../bfd/version.h $(srcdir)/../gdbsupport/create-version.sh
 	$(ECHO_GEN) $(SHELL) $(srcdir)/../gdbsupport/create-version.sh $(srcdir)/../gdb \
 		$(host_alias) $(target_alias) $@
 
-xml-builtin-generated.c: stamp-xml; @true
+xml-builtin-generated.cc: stamp-xml; @true
 stamp-xml: $(XML_DIR)/feature_to_c.sh Makefile $(XML_FILES)
 	$(SILENCE) rm -f xml-builtin.tmp
 	$(ECHO_GEN_XML_BUILTIN_GENERATED) $(SHELL) $(XML_DIR)/feature_to_c.sh \
 		xml-builtin.tmp $(XML_FILES)
-	$(SILENCE) $(SHELL) $(srcdir)/../move-if-change xml-builtin.tmp xml-builtin-generated.c
+	$(SILENCE) $(SHELL) $(srcdir)/../move-if-change xml-builtin.tmp xml-builtin-generated.cc
 	$(SILENCE) echo stamp > stamp-xml
 
-.PRECIOUS: xml-builtin.c
+.PRECIOUS: xml-builtin.cc
 
 # GNU Make has an annoying habit of putting *all* the Makefile variables
 # into the environment, unless you include this target as a circumvention.
@@ -586,87 +586,87 @@ IPAGENT_COMPILE = $(ECHO_CXX) $(COMPILE.pre) $(IPAGENT_CFLAGS) $(COMPILE.post)
 
 # Rules for special cases.
 
-ax-ipa.o: ax.c
+ax-ipa.o: ax.cc
 	$(IPAGENT_COMPILE) $(WARN_CFLAGS_NO_FORMAT) $<
 	$(POSTCOMPILE)
 
-ax.o: ax.c
+ax.o: ax.cc
 	$(COMPILE) $(WARN_CFLAGS_NO_FORMAT) $<
 	$(POSTCOMPILE)
 
 # Rules for objects that go in the in-process agent.
 
 arch/%-ipa.o: ../gdb/arch/%.c
-	$(IPAGENT_COMPILE) $<
+	$(IPAGENT_COMPILE) -x c++ $<
 	$(POSTCOMPILE)
 
 gdbsupport/%-ipa.o: ../gdbsupport/%.cc
 	$(IPAGENT_COMPILE) $<
 	$(POSTCOMPILE)
 
-%-ipa.o: %-generated.c
+%-ipa.o: %-generated.cc
 	$(IPAGENT_COMPILE) $<
 	$(POSTCOMPILE)
 
-%-ipa.o: %.c
+%-ipa.o: %.cc
 	$(IPAGENT_COMPILE) $<
 	$(POSTCOMPILE)
 
 %-ipa.o: ../gdb/%.c
-	$(IPAGENT_COMPILE) $<
+	$(IPAGENT_COMPILE) -x c++ $<
 	$(POSTCOMPILE)
 
 # Note: Between two matching pattern rules, GNU Make 3.81 chooses the first one.
-# Therefore, this one needs to be before "%.o: %.c" for it to be considered for
-# files such as linux-amd64-ipa.o generated from linux-amd64-ipa.c.
+# Therefore, this one needs to be before "%.o: %.cc" for it to be considered for
+# files such as linux-amd64-ipa.o generated from linux-amd64-ipa.cc.
 #
 # Later versions of GNU Make choose the rule with the shortest stem, so it would
 # work in any order.
 
-%-ipa.o: %-ipa.c
+%-ipa.o: %-ipa.cc
 	$(IPAGENT_COMPILE) $<
 	$(POSTCOMPILE)
 
 # Rules for objects that go in the gdbserver binary.
 
 arch/%.o: ../gdb/arch/%.c
-	$(COMPILE) $<
+	$(COMPILE) -x c++ $<
 	$(POSTCOMPILE)
 
 gdbsupport/%.o: ../gdbsupport/%.cc
 	$(COMPILE) $<
 	$(POSTCOMPILE)
 
-%.o: %-generated.c
+%.o: %-generated.cc
 	$(COMPILE) $<
 	$(POSTCOMPILE)
 
-%.o: %.c
+%.o: %.cc
 	$(COMPILE) $<
 	$(POSTCOMPILE)
 
 nat/%.o: ../gdb/nat/%.c
-	$(COMPILE) $<
+	$(COMPILE) -x c++ $<
 	$(POSTCOMPILE)
 
 target/%.o: ../gdb/target/%.c
-	$(COMPILE) $<
+	$(COMPILE) -x c++ $<
 	$(POSTCOMPILE)
 
 %.o: ../gdb/%.c
-	$(COMPILE) $<
+	$(COMPILE) -x c++ $<
 	$(POSTCOMPILE)
 
 # Rules for register format descriptions.  Suffix destination files with
 # -generated to identify and clean them easily.
 
-%-generated.c: ../gdb/regformats/%.dat $(regdat_sh)
+%-generated.cc: ../gdb/regformats/%.dat $(regdat_sh)
 	$(ECHO_REGDAT) $(SHELL) $(regdat_sh) $< $@
 
-%-generated.c: ../gdb/regformats/arm/%.dat $(regdat_sh)
+%-generated.cc: ../gdb/regformats/arm/%.dat $(regdat_sh)
 	$(ECHO_REGDAT) $(SHELL) $(regdat_sh) $< $@
 
-%-generated.c: ../gdb/regformats/rs6000/%.dat $(regdat_sh)
+%-generated.cc: ../gdb/regformats/rs6000/%.dat $(regdat_sh)
 	$(ECHO_REGDAT) $(SHELL) $(regdat_sh) $< $@
 
 #
@@ -684,7 +684,7 @@ override POSTCOMPILE = @mv $(@D)/$(DEPDIR)/$(basename $(@F)).Tpo \
 else
 override COMPILE.pre = source='$<' object='$@' libtool=no \
 	DEPDIR=$(DEPDIR) $(DEPMODE) $(depcomp) \
-	$(CXX) -x c++ $(CXX_DIALECT)
+	$(CXX) $(CXX_DIALECT)
 # depcomp handles atomicity for us, so we don't need a postcompile
 # step.
 override POSTCOMPILE =
@@ -713,7 +713,7 @@ all_deps_files = $(foreach dep,$(patsubst %.o,%.Po,$(all_object_files)),\
 # Disable implicit make rules.
 include $(srcdir)/../gdb/disable-implicit-rules.mk
 
-# Do not delete intermediate files (e.g. *-generated.c).
+# Do not delete intermediate files (e.g. *-generated.cc).
 .SECONDARY:
 
 # This is the end of "Makefile.in".
diff --git a/gdbserver/ax.c b/gdbserver/ax.cc
similarity index 100%
rename from gdbserver/ax.c
rename to gdbserver/ax.cc
diff --git a/gdbserver/configure b/gdbserver/configure
index 71b515ec955a..7d42803f640d 100755
--- a/gdbserver/configure
+++ b/gdbserver/configure
@@ -582,7 +582,7 @@ PACKAGE_STRING=
 PACKAGE_BUGREPORT=
 PACKAGE_URL=
 
-ac_unique_file="server.c"
+ac_unique_file="server.cc"
 # Factoring default headers for most tests.
 ac_includes_default="\
 #include <stdio.h>
diff --git a/gdbserver/configure.ac b/gdbserver/configure.ac
index 285a297a1c6c..0da2bfa95e46 100644
--- a/gdbserver/configure.ac
+++ b/gdbserver/configure.ac
@@ -18,7 +18,7 @@ dnl along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 dnl Process this file with autoconf to produce a configure script.
 
-AC_INIT(server.c)
+AC_INIT(server.cc)
 AC_CONFIG_HEADERS(config.h:config.in, [echo > stamp-h])
 
 AM_MAINTAINER_MODE
diff --git a/gdbserver/debug.c b/gdbserver/debug.cc
similarity index 100%
rename from gdbserver/debug.c
rename to gdbserver/debug.cc
diff --git a/gdbserver/dll.c b/gdbserver/dll.cc
similarity index 100%
rename from gdbserver/dll.c
rename to gdbserver/dll.cc
diff --git a/gdbserver/event-loop.c b/gdbserver/event-loop.cc
similarity index 100%
rename from gdbserver/event-loop.c
rename to gdbserver/event-loop.cc
diff --git a/gdbserver/fork-child.c b/gdbserver/fork-child.cc
similarity index 100%
rename from gdbserver/fork-child.c
rename to gdbserver/fork-child.cc
diff --git a/gdbserver/gdbreplay.c b/gdbserver/gdbreplay.cc
similarity index 100%
rename from gdbserver/gdbreplay.c
rename to gdbserver/gdbreplay.cc
diff --git a/gdbserver/hostio-errno.c b/gdbserver/hostio-errno.cc
similarity index 100%
rename from gdbserver/hostio-errno.c
rename to gdbserver/hostio-errno.cc
diff --git a/gdbserver/hostio.c b/gdbserver/hostio.cc
similarity index 100%
rename from gdbserver/hostio.c
rename to gdbserver/hostio.cc
diff --git a/gdbserver/i387-fp.c b/gdbserver/i387-fp.cc
similarity index 100%
rename from gdbserver/i387-fp.c
rename to gdbserver/i387-fp.cc
diff --git a/gdbserver/inferiors.c b/gdbserver/inferiors.cc
similarity index 100%
rename from gdbserver/inferiors.c
rename to gdbserver/inferiors.cc
diff --git a/gdbserver/linux-aarch32-low.c b/gdbserver/linux-aarch32-low.cc
similarity index 100%
rename from gdbserver/linux-aarch32-low.c
rename to gdbserver/linux-aarch32-low.cc
diff --git a/gdbserver/linux-aarch32-tdesc.c b/gdbserver/linux-aarch32-tdesc.cc
similarity index 100%
rename from gdbserver/linux-aarch32-tdesc.c
rename to gdbserver/linux-aarch32-tdesc.cc
diff --git a/gdbserver/linux-aarch64-ipa.c b/gdbserver/linux-aarch64-ipa.cc
similarity index 100%
rename from gdbserver/linux-aarch64-ipa.c
rename to gdbserver/linux-aarch64-ipa.cc
diff --git a/gdbserver/linux-aarch64-low.c b/gdbserver/linux-aarch64-low.cc
similarity index 100%
rename from gdbserver/linux-aarch64-low.c
rename to gdbserver/linux-aarch64-low.cc
diff --git a/gdbserver/linux-aarch64-tdesc.c b/gdbserver/linux-aarch64-tdesc.cc
similarity index 100%
rename from gdbserver/linux-aarch64-tdesc.c
rename to gdbserver/linux-aarch64-tdesc.cc
diff --git a/gdbserver/linux-amd64-ipa.c b/gdbserver/linux-amd64-ipa.cc
similarity index 100%
rename from gdbserver/linux-amd64-ipa.c
rename to gdbserver/linux-amd64-ipa.cc
diff --git a/gdbserver/linux-arm-low.c b/gdbserver/linux-arm-low.cc
similarity index 100%
rename from gdbserver/linux-arm-low.c
rename to gdbserver/linux-arm-low.cc
diff --git a/gdbserver/linux-arm-tdesc.c b/gdbserver/linux-arm-tdesc.cc
similarity index 100%
rename from gdbserver/linux-arm-tdesc.c
rename to gdbserver/linux-arm-tdesc.cc
diff --git a/gdbserver/linux-bfin-low.c b/gdbserver/linux-bfin-low.cc
similarity index 100%
rename from gdbserver/linux-bfin-low.c
rename to gdbserver/linux-bfin-low.cc
diff --git a/gdbserver/linux-cris-low.c b/gdbserver/linux-cris-low.cc
similarity index 100%
rename from gdbserver/linux-cris-low.c
rename to gdbserver/linux-cris-low.cc
diff --git a/gdbserver/linux-crisv32-low.c b/gdbserver/linux-crisv32-low.cc
similarity index 100%
rename from gdbserver/linux-crisv32-low.c
rename to gdbserver/linux-crisv32-low.cc
diff --git a/gdbserver/linux-i386-ipa.c b/gdbserver/linux-i386-ipa.cc
similarity index 100%
rename from gdbserver/linux-i386-ipa.c
rename to gdbserver/linux-i386-ipa.cc
diff --git a/gdbserver/linux-ia64-low.c b/gdbserver/linux-ia64-low.cc
similarity index 100%
rename from gdbserver/linux-ia64-low.c
rename to gdbserver/linux-ia64-low.cc
diff --git a/gdbserver/linux-low.c b/gdbserver/linux-low.cc
similarity index 100%
rename from gdbserver/linux-low.c
rename to gdbserver/linux-low.cc
diff --git a/gdbserver/linux-m32r-low.c b/gdbserver/linux-m32r-low.cc
similarity index 100%
rename from gdbserver/linux-m32r-low.c
rename to gdbserver/linux-m32r-low.cc
diff --git a/gdbserver/linux-m68k-low.c b/gdbserver/linux-m68k-low.cc
similarity index 100%
rename from gdbserver/linux-m68k-low.c
rename to gdbserver/linux-m68k-low.cc
diff --git a/gdbserver/linux-mips-low.c b/gdbserver/linux-mips-low.cc
similarity index 100%
rename from gdbserver/linux-mips-low.c
rename to gdbserver/linux-mips-low.cc
diff --git a/gdbserver/linux-nios2-low.c b/gdbserver/linux-nios2-low.cc
similarity index 100%
rename from gdbserver/linux-nios2-low.c
rename to gdbserver/linux-nios2-low.cc
diff --git a/gdbserver/linux-ppc-ipa.c b/gdbserver/linux-ppc-ipa.cc
similarity index 100%
rename from gdbserver/linux-ppc-ipa.c
rename to gdbserver/linux-ppc-ipa.cc
diff --git a/gdbserver/linux-ppc-low.c b/gdbserver/linux-ppc-low.cc
similarity index 100%
rename from gdbserver/linux-ppc-low.c
rename to gdbserver/linux-ppc-low.cc
diff --git a/gdbserver/linux-s390-ipa.c b/gdbserver/linux-s390-ipa.cc
similarity index 100%
rename from gdbserver/linux-s390-ipa.c
rename to gdbserver/linux-s390-ipa.cc
diff --git a/gdbserver/linux-s390-low.c b/gdbserver/linux-s390-low.cc
similarity index 100%
rename from gdbserver/linux-s390-low.c
rename to gdbserver/linux-s390-low.cc
diff --git a/gdbserver/linux-sh-low.c b/gdbserver/linux-sh-low.cc
similarity index 100%
rename from gdbserver/linux-sh-low.c
rename to gdbserver/linux-sh-low.cc
diff --git a/gdbserver/linux-sparc-low.c b/gdbserver/linux-sparc-low.cc
similarity index 100%
rename from gdbserver/linux-sparc-low.c
rename to gdbserver/linux-sparc-low.cc
diff --git a/gdbserver/linux-tic6x-low.c b/gdbserver/linux-tic6x-low.cc
similarity index 100%
rename from gdbserver/linux-tic6x-low.c
rename to gdbserver/linux-tic6x-low.cc
diff --git a/gdbserver/linux-tile-low.c b/gdbserver/linux-tile-low.cc
similarity index 100%
rename from gdbserver/linux-tile-low.c
rename to gdbserver/linux-tile-low.cc
diff --git a/gdbserver/linux-x86-low.c b/gdbserver/linux-x86-low.cc
similarity index 100%
rename from gdbserver/linux-x86-low.c
rename to gdbserver/linux-x86-low.cc
diff --git a/gdbserver/linux-x86-tdesc.c b/gdbserver/linux-x86-tdesc.cc
similarity index 100%
rename from gdbserver/linux-x86-tdesc.c
rename to gdbserver/linux-x86-tdesc.cc
diff --git a/gdbserver/linux-xtensa-low.c b/gdbserver/linux-xtensa-low.cc
similarity index 100%
rename from gdbserver/linux-xtensa-low.c
rename to gdbserver/linux-xtensa-low.cc
diff --git a/gdbserver/lynx-i386-low.c b/gdbserver/lynx-i386-low.cc
similarity index 100%
rename from gdbserver/lynx-i386-low.c
rename to gdbserver/lynx-i386-low.cc
diff --git a/gdbserver/lynx-low.c b/gdbserver/lynx-low.cc
similarity index 100%
rename from gdbserver/lynx-low.c
rename to gdbserver/lynx-low.cc
diff --git a/gdbserver/lynx-ppc-low.c b/gdbserver/lynx-ppc-low.cc
similarity index 100%
rename from gdbserver/lynx-ppc-low.c
rename to gdbserver/lynx-ppc-low.cc
diff --git a/gdbserver/mem-break.c b/gdbserver/mem-break.cc
similarity index 100%
rename from gdbserver/mem-break.c
rename to gdbserver/mem-break.cc
diff --git a/gdbserver/notif.c b/gdbserver/notif.cc
similarity index 100%
rename from gdbserver/notif.c
rename to gdbserver/notif.cc
diff --git a/gdbserver/nto-low.c b/gdbserver/nto-low.cc
similarity index 100%
rename from gdbserver/nto-low.c
rename to gdbserver/nto-low.cc
diff --git a/gdbserver/nto-x86-low.c b/gdbserver/nto-x86-low.cc
similarity index 100%
rename from gdbserver/nto-x86-low.c
rename to gdbserver/nto-x86-low.cc
diff --git a/gdbserver/proc-service.c b/gdbserver/proc-service.cc
similarity index 100%
rename from gdbserver/proc-service.c
rename to gdbserver/proc-service.cc
diff --git a/gdbserver/regcache.c b/gdbserver/regcache.cc
similarity index 100%
rename from gdbserver/regcache.c
rename to gdbserver/regcache.cc
diff --git a/gdbserver/remote-utils.c b/gdbserver/remote-utils.cc
similarity index 100%
rename from gdbserver/remote-utils.c
rename to gdbserver/remote-utils.cc
diff --git a/gdbserver/server.c b/gdbserver/server.cc
similarity index 100%
rename from gdbserver/server.c
rename to gdbserver/server.cc
diff --git a/gdbserver/symbol.c b/gdbserver/symbol.cc
similarity index 100%
rename from gdbserver/symbol.c
rename to gdbserver/symbol.cc
diff --git a/gdbserver/target.c b/gdbserver/target.cc
similarity index 100%
rename from gdbserver/target.c
rename to gdbserver/target.cc
diff --git a/gdbserver/tdesc.c b/gdbserver/tdesc.cc
similarity index 100%
rename from gdbserver/tdesc.c
rename to gdbserver/tdesc.cc
diff --git a/gdbserver/thread-db.c b/gdbserver/thread-db.cc
similarity index 100%
rename from gdbserver/thread-db.c
rename to gdbserver/thread-db.cc
diff --git a/gdbserver/tracepoint.c b/gdbserver/tracepoint.cc
similarity index 100%
rename from gdbserver/tracepoint.c
rename to gdbserver/tracepoint.cc
diff --git a/gdbserver/utils.c b/gdbserver/utils.cc
similarity index 100%
rename from gdbserver/utils.c
rename to gdbserver/utils.cc
diff --git a/gdbserver/win32-arm-low.c b/gdbserver/win32-arm-low.cc
similarity index 100%
rename from gdbserver/win32-arm-low.c
rename to gdbserver/win32-arm-low.cc
diff --git a/gdbserver/win32-i386-low.c b/gdbserver/win32-i386-low.cc
similarity index 100%
rename from gdbserver/win32-i386-low.c
rename to gdbserver/win32-i386-low.cc
diff --git a/gdbserver/win32-low.c b/gdbserver/win32-low.cc
similarity index 100%
rename from gdbserver/win32-low.c
rename to gdbserver/win32-low.cc
diff --git a/gdbserver/wincecompat.c b/gdbserver/wincecompat.cc
similarity index 100%
rename from gdbserver/wincecompat.c
rename to gdbserver/wincecompat.cc
diff --git a/gdbserver/x86-low.c b/gdbserver/x86-low.cc
similarity index 100%
rename from gdbserver/x86-low.c
rename to gdbserver/x86-low.cc
diff --git a/gdbserver/xtensa-xtregs.c b/gdbserver/xtensa-xtregs.cc
similarity index 100%
rename from gdbserver/xtensa-xtregs.c
rename to gdbserver/xtensa-xtregs.cc